ON_TextureMapping Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_texture_mapping.h>`

Inheritance diagram for ON_TextureMapping:

## Public Types

enum | TYPE { no_mapping = 0, srfp_mapping = 1, plane_mapping = 2, cylinder_mapping = 3, sphere_mapping = 4, box_mapping = 5, mesh_mapping_primitive = 6, srf_mapping_primitive = 7, brep_mapping_primitive = 8, force_32bit_mapping_type = 0xFFFFFFFF }
enum | PROJECTION { no_projection = 0, clspt_projection = 1, ray_projection = 2, force_32bit_mapping_projection = 0xFFFFFFFF }
enum | TEXTURE_SPACE { single = 0, divided = 1, force_32bit_texture_space = 0xFFFFFFFF }

## Public Member Functions

| ON_OBJECT_DECLARE (ON_TextureMapping)
| ON_TextureMapping ()
| ~ON_TextureMapping ()
| ON_TextureMapping (const ON_TextureMapping &src)
ON_TextureMapping & | operator= (const ON_TextureMapping &src)
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
unsigned int | SizeOf () const
ON_BOOL32 | Write (ON_BinaryArchive &binary_archive) const
ON_BOOL32 | Read (ON_BinaryArchive &binary_archive)
void | Default ()
virtual ON_UUID | ModelObjectId () const
bool | RequiresVertexNormals () const
bool | IsPeriodic (void) const
bool | SetSurfaceParameterMapping (void)
bool | SetPlaneMapping (const ON_Plane &plane, const ON_Interval &dx, const ON_Interval &dy, const ON_Interval &dz)
bool | SetCylinderMapping (const ON_Cylinder &cylinder, bool bIsCapped)
bool | SetSphereMapping (const ON_Sphere &sphere)
bool | SetBoxMapping (const ON_Plane &plane, ON_Interval dx, ON_Interval dy, ON_Interval dz, bool bIsCapped)
bool | GetMappingPlane (ON_Plane &plane, ON_Interval &dx, ON_Interval &dy, ON_Interval &dz) const
bool | GetMappingCylinder (ON_Cylinder &cylinder) const
bool | GetMappingSphere (ON_Sphere &sphere) const
bool | GetMappingBox (ON_Plane &plane, ON_Interval &dx, ON_Interval &dy, ON_Interval &dz) const
bool | ReverseTextureCoordinate (int dir)
bool | SwapTextureCoordinate (int i, int j)
bool | TileTextureCoordinate (int dir, double count, double offset)
virtual int | Evaluate (const ON_3dPoint &P, const ON_3dVector &N, ON_3dPoint *T) const
virtual int | Evaluate (const ON_3dPoint &P, const ON_3dVector &N, ON_3dPoint *T, const ON_Xform &P_xform, const ON_Xform &N_xform) const
int | EvaluatePlaneMapping (const ON_3dPoint &P, const ON_3dVector &N, ON_3dPoint *T) const
int | EvaluateSphereMapping (const ON_3dPoint &P, const ON_3dVector &N, ON_3dPoint *T) const
int | EvaluateCylinderMapping (const ON_3dPoint &P, const ON_3dVector &N, ON_3dPoint *T) const
int | EvaluateBoxMapping (const ON_3dPoint &P, const ON_3dVector &N, ON_3dPoint *T) const
bool | HasMatchingTextureCoordinates (const ON_Mesh &mesh, const ON_Xform *object_xform=0) const
bool | HasMatchingTextureCoordinates (const class ON_MappingTag &tag, const ON_Xform *object_xform=0) const
bool | GetTextureCoordinates (const ON_Mesh &mesh, ON_SimpleArray< ON_3fPoint > &T, const ON_Xform *mesh_xform=0, bool bLazy=false, ON_SimpleArray< int > *Tside=0) const
bool | GetTextureCoordinates (const ON_Mesh &mesh, ON_SimpleArray< ON_2fPoint > &T, const ON_Xform *mesh_xform=0, bool bLazy=false, ON_SimpleArray< int > *Tside=0) const
ON__UINT32 | MappingCRC () const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
virtual ON::object_type | ObjectType () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Static Public Member Functions

static TYPE | TypeFromInt (int i)
static PROJECTION | ProjectionFromInt (int i)
static TEXTURE_SPACE | TextureSpaceFromInt (int i)

## Public Attributes

ON_UUID | m_mapping_id
int | m_mapping_index
ON_wString | m_mapping_name
TYPE | m_type
PROJECTION | m_projection
TEXTURE_SPACE | m_texture_space
bool | m_bCapped
ON_Xform | m_Pxyz
ON_Xform | m_Nxyz
ON_Xform | m_uvw
ON_Object * | m_mapping_primitive

## Detailed Description

Definition at line 37 of file opennurbs_texture_mapping.h.

## Member Enumeration Documentation

## PROJECTION

enum ON_TextureMapping::PROJECTION

Enumerator
no_projection |
clspt_projection |
ray_projection |
force_32bit_mapping_projection |

Definition at line 609 of file opennurbs_texture_mapping.h.

## TEXTURE_SPACE

enum ON_TextureMapping::TEXTURE_SPACE

Enumerator
single |
divided |
force_32bit_texture_space |

Definition at line 629 of file opennurbs_texture_mapping.h.

## TYPE

enum ON_TextureMapping::TYPE

Enumerator
no_mapping |
srfp_mapping |
plane_mapping |
cylinder_mapping |
sphere_mapping |
box_mapping |
mesh_mapping_primitive |
srf_mapping_primitive |
brep_mapping_primitive |
force_32bit_mapping_type |

Definition at line 569 of file opennurbs_texture_mapping.h.

## Constructor & Destructor Documentation

## ON_TextureMapping() [1/2]

ON_TextureMapping::ON_TextureMapping | ( |  | ) |

## ~ON_TextureMapping()

ON_TextureMapping::~ON_TextureMapping | ( |  | ) |

## ON_TextureMapping() [2/2]

ON_TextureMapping::ON_TextureMapping | ( | const ON_TextureMapping & | src | ) |

## Member Function Documentation

## Default()

void ON_TextureMapping::Default | ( |  | ) |

## Dump()

void ON_TextureMapping::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## Evaluate() [1/2]

virtual int ON_TextureMapping::Evaluate | ( | const ON_3dPoint & | P,
|  | const ON_3dVector & | N,
|  | ON_3dPoint * | T
| ) |  | const

virtual

## Evaluate() [2/2]

virtual int ON_TextureMapping::Evaluate | ( | const ON_3dPoint & | P,
|  | const ON_3dVector & | N,
|  | ON_3dPoint * | T,
|  | const ON_Xform & | P_xform,
|  | const ON_Xform & | N_xform
| ) |  | const

virtual

## EvaluateBoxMapping()

int ON_TextureMapping::EvaluateBoxMapping | ( | const ON_3dPoint & | P,
|  | const ON_3dVector & | N,
|  | ON_3dPoint * | T
| ) |  | const

## EvaluateCylinderMapping()

int ON_TextureMapping::EvaluateCylinderMapping | ( | const ON_3dPoint & | P,
|  | const ON_3dVector & | N,
|  | ON_3dPoint * | T
| ) |  | const

## EvaluatePlaneMapping()

int ON_TextureMapping::EvaluatePlaneMapping | ( | const ON_3dPoint & | P,
|  | const ON_3dVector & | N,
|  | ON_3dPoint * | T
| ) |  | const

## EvaluateSphereMapping()

int ON_TextureMapping::EvaluateSphereMapping | ( | const ON_3dPoint & | P,
|  | const ON_3dVector & | N,
|  | ON_3dPoint * | T
| ) |  | const

## GetMappingBox()

bool ON_TextureMapping::GetMappingBox | ( | ON_Plane & | plane,
|  | ON_Interval & | dx,
|  | ON_Interval & | dy,
|  | ON_Interval & | dz
| ) |  | const

## GetMappingCylinder()

bool ON_TextureMapping::GetMappingCylinder | ( | ON_Cylinder & | cylinder | ) | const

## GetMappingPlane()

bool ON_TextureMapping::GetMappingPlane | ( | ON_Plane & | plane,
|  | ON_Interval & | dx,
|  | ON_Interval & | dy,
|  | ON_Interval & | dz
| ) |  | const

## GetMappingSphere()

bool ON_TextureMapping::GetMappingSphere | ( | ON_Sphere & | sphere | ) | const

## GetTextureCoordinates() [1/2]

bool ON_TextureMapping::GetTextureCoordinates | ( | const ON_Mesh & | mesh,
|  | ON_SimpleArray< ON_3fPoint > & | T,
|  | const ON_Xform * | mesh_xform = `0`,
|  | bool | bLazy = `false`,
|  | ON_SimpleArray< int > * | Tside = `0`
| ) |  | const

## GetTextureCoordinates() [2/2]

bool ON_TextureMapping::GetTextureCoordinates | ( | const ON_Mesh & | mesh,
|  | ON_SimpleArray< ON_2fPoint > & | T,
|  | const ON_Xform * | mesh_xform = `0`,
|  | bool | bLazy = `false`,
|  | ON_SimpleArray< int > * | Tside = `0`
| ) |  | const

## HasMatchingTextureCoordinates() [1/2]

bool ON_TextureMapping::HasMatchingTextureCoordinates | ( | const ON_Mesh & | mesh,
|  | const ON_Xform * | object_xform = `0`
| ) |  | const

## HasMatchingTextureCoordinates() [2/2]

bool ON_TextureMapping::HasMatchingTextureCoordinates | ( | const class ON_MappingTag & | tag,
|  | const ON_Xform * | object_xform = `0`
| ) |  | const

## IsPeriodic()

bool ON_TextureMapping::IsPeriodic | ( | void |  | ) | const

## IsValid()

ON_BOOL32 ON_TextureMapping::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## MappingCRC()

ON__UINT32 ON_TextureMapping::MappingCRC | ( |  | ) | const

## ModelObjectId()

virtual ON_UUID ON_TextureMapping::ModelObjectId | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## ON_OBJECT_DECLARE()

ON_TextureMapping::ON_OBJECT_DECLARE | ( | ON_TextureMapping |  | ) |

## operator=()

ON_TextureMapping& ON_TextureMapping::operator= | ( | const ON_TextureMapping & | src | ) |

## ProjectionFromInt()

static PROJECTION ON_TextureMapping::ProjectionFromInt | ( | int | i | ) |

static

## Read()

ON_BOOL32 ON_TextureMapping::Read | ( | ON_BinaryArchive & | binary_archive | ) |

virtual

Reimplemented from ON_Object.

## RequiresVertexNormals()

bool ON_TextureMapping::RequiresVertexNormals | ( |  | ) | const

## ReverseTextureCoordinate()

bool ON_TextureMapping::ReverseTextureCoordinate | ( | int | dir | ) |

## SetBoxMapping()

bool ON_TextureMapping::SetBoxMapping | ( | const ON_Plane & | plane,
|  | ON_Interval | dx,
|  | ON_Interval | dy,
|  | ON_Interval | dz,
|  | bool | bIsCapped
| ) |  |

## SetCylinderMapping()

bool ON_TextureMapping::SetCylinderMapping | ( | const ON_Cylinder & | cylinder,
|  | bool | bIsCapped
| ) |  |

## SetPlaneMapping()

bool ON_TextureMapping::SetPlaneMapping | ( | const ON_Plane & | plane,
|  | const ON_Interval & | dx,
|  | const ON_Interval & | dy,
|  | const ON_Interval & | dz
| ) |  |

## SetSphereMapping()

bool ON_TextureMapping::SetSphereMapping | ( | const ON_Sphere & | sphere | ) |

## SetSurfaceParameterMapping()

bool ON_TextureMapping::SetSurfaceParameterMapping | ( | void |  | ) |

## SizeOf()

unsigned int ON_TextureMapping::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## SwapTextureCoordinate()

bool ON_TextureMapping::SwapTextureCoordinate | ( | int | i,
|  | int | j
| ) |  |

## TextureSpaceFromInt()

static TEXTURE_SPACE ON_TextureMapping::TextureSpaceFromInt | ( | int | i | ) |

static

## TileTextureCoordinate()

bool ON_TextureMapping::TileTextureCoordinate | ( | int | dir,
|  | double | count,
|  | double | offset
| ) |  |

## TypeFromInt()

static TYPE ON_TextureMapping::TypeFromInt | ( | int | i | ) |

static

## Write()

ON_BOOL32 ON_TextureMapping::Write | ( | ON_BinaryArchive & | binary_archive | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

## m_bCapped

bool ON_TextureMapping::m_bCapped

Definition at line 646 of file opennurbs_texture_mapping.h.

## m_mapping_id

ON_UUID ON_TextureMapping::m_mapping_id

Definition at line 544 of file opennurbs_texture_mapping.h.

## m_mapping_index

int ON_TextureMapping::m_mapping_index

Definition at line 552 of file opennurbs_texture_mapping.h.

## m_mapping_name

ON_wString ON_TextureMapping::m_mapping_name

Definition at line 556 of file opennurbs_texture_mapping.h.

## m_mapping_primitive

ON_Object* ON_TextureMapping::m_mapping_primitive

Definition at line 666 of file opennurbs_texture_mapping.h.

## m_Nxyz

ON_Xform ON_TextureMapping::m_Nxyz

Definition at line 659 of file opennurbs_texture_mapping.h.

## m_projection

PROJECTION ON_TextureMapping::m_projection

Definition at line 617 of file opennurbs_texture_mapping.h.

## m_Pxyz

ON_Xform ON_TextureMapping::m_Pxyz

Definition at line 658 of file opennurbs_texture_mapping.h.

## m_texture_space

TEXTURE_SPACE ON_TextureMapping::m_texture_space

Definition at line 640 of file opennurbs_texture_mapping.h.

## m_type

TYPE ON_TextureMapping::m_type

Definition at line 585 of file opennurbs_texture_mapping.h.

## m_uvw

ON_Xform ON_TextureMapping::m_uvw

Definition at line 663 of file opennurbs_texture_mapping.h.

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_texture_mapping.h